## stockfish 6

=== debian/changelog ===
stockfish (6-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release 6 (Closes: #797327)
    - Closes: #699309 (fixed in 5.0 according to bug comment #17)
  * Drop quilt.
  * Update watch file.
  * Use quilt format.
  * Update copyright file.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 12 Oct 2015 14:46:27 +0200

stockfish (5.0.dd+git20140823-1) unstable; urgency=low

  * New Upstream Version 5 (Closes: #756546)
  * No polyglot.ini in the sources anymore, patch removed
  * I am considering moving to the sources with Syzygy tablebases. If 
    anybody has an opinion on that matter file a bug with explanation.

 -- Oliver Korff <ok@xynyx.de>  Sat, 23 Aug 2014 16:43:44 +0200

stockfish (4.0.dd+git20140122-1) unstable; urgency=low

  * New Upstream Version 4 (Closes: #730504)
  * Removed makefile_patch_02 not needed anymore 
  * Upgraded to Standards-Version 3.9.5, no package changes
  * Changed the binary path in polyglot.ini to /usr/games/stockfish 
    Thx to Francesco Poli for filing the bug (Closes: #728920)
  * Changes to the watchfile, but this will not help scanning for new 
    Versions. 

 -- Oliver Korff <ok@xynyx.de>  Thu, 20 Feb 2014 22:31:10 +0100

stockfish (3.0.0+git20130508-2) unstable; urgency=low

  * Upstream version 3.(Closes: #706554) 
  * After fighting with the chroot environment on merulo I solved the 
    build problem on ia64 and added a target for the arch to the rules file: 
    profile-build ARCH=general-64 optimize=no (Closes: #679174)

 -- Oliver Korff <ok@xynyx.de>  Sun, 09 Jun 2013 21:07:19 +0200

stockfish (3.0.0+git20130508-1) unstable; urgency=low

  * New Upstream version. (Closes: #706554)
  * The prefetch behaviour is now changed by upstream, so the 
    makefile_patch_03 is not needed anymore.

 -- Oliver Korff <ok@xynyx.de>  Sat, 08 Jun 2013 16:34:32 +0200

stockfish (2.3.1+git20121008-2) unstable; urgency=low

  * FTBFS on various archs due to a Makefile target change. This is fixed 
    now by changing the prefetch behaviour. 

 -- Oliver Korff <ok@xynyx.de>  Fri, 12 Oct 2012 02:23:09 +0200

stockfish (2.3.1+git20121008-1) unstable; urgency=low

  * New Upstream version.
  * Updated to Standards-Version 3.9.4. No package changes.
  * Use dh_auto_build in rules (instead of make directly) and compat 
    level 9 instead of 7. This sets the hardening build flags by 
    default. 
    The controlfile had to be ajusted to debhelper (>= 9). And the 
    patch makefile_patch_02 is intrduced to make the hardening 
    environment CXXFLAGS and LDFLAGS visible to the makefile.


 -- Oliver Korff <ok@xynyx.de>  Thu, 11 Oct 2012 17:05:55 +0200

stockfish (2.2.2+git20120201-1) unstable; urgency=low

  * New Upstream version.

 -- Oliver Korff <ok@xynyx.de>  Thu, 02 Feb 2012 00:01:04 +0100

stockfish (2.2.1+git20120109-1) unstable; urgency=low

  * New Upstream version.
  * Removed debian/patches/add-lgov-linker.patch: makes build fail on debian,
    the upstream Makefile now includes lgcov.

 -- Oliver Korff <ok@xynyx.de>  Mon, 09 Jan 2012 23:30:22 +0100

stockfish (2.1.1+git20111006-2) unstable; urgency=low

  * debian/patches/add-lgov-linker.patch: Add -lgcov library linker to fixing
    FTBFS ld no-add-needed. (LP: #832862) Thanks to Mahyuddin Susanto.

 -- Oliver Korff <ok@xynyx.de>  Tue, 08 Nov 2011 10:16:52 +0100

stockfish (2.1.1+git20111006-1) unstable; urgency=low

  * Upstream has now moved to git. 
    https://github.com/mcostalba/Stockfish.git
    All changes are said to be code cleanups and no feature changes.
  * Debian specific update to support m86k. 
  * Basic support for DEB_BUILD_OPTIONS. The option nocheck will drop
    the testsuite and noopts will at least drop the profiling.
  * Adjusted download location in copyright.

 -- Oliver Korff <ok@xynyx.de>  Thu, 15 Sep 2011 00:12:59 +0200

stockfish (2.1.1-1) unstable; urgency=low

  * New Upstream version. Its a maintenance release.
  * Repack of the source distribution due to the included binary files. Removed: 
    stockfish-211-64-ja stockfish-211-32-ja stockfish-211-64-ja.exe 
    stockfish-211-32-ja.exe stockfish-211-android-ja
  * Removed build dependency to g++-4.4 (>= 4.4.5), maybe we don't need this 
    anymore. Lets see, if the other architectures will build fine...
  * Updated to Standards-Version 3.9.2. No package changes.
  * Removed duplicat Homepage field from contreol.

 -- Oliver Korff <ok@xynyx.de>  Tue, 10 May 2011 09:29:35 +0200

stockfish (2.0.1-2) unstable; urgency=low

  * Upload to unstable.
  * For sparc there is no profiling anymore, because I never received more 
    info on the bugreport. (Closes: #599979)
  * Added a Homepage: field to control file. 

 -- Oliver Korff <ok@xynyx.de>  Thu, 24 Feb 2011 16:28:14 +0100

stockfish (2.0.1-1) experimental; urgency=low

  * New Upstream version.
  * Upstream uses now the RKISS random generator for hash keys (courtesy of 
    Heinz van Saanen) instead of mersenne, so I adjusted the copyright notice.

 -- Oliver Korff <ok@xynyx.de>  Tue, 11 Jan 2011 09:31:01 +0100

stockfish (1.9.1-3) experimental; urgency=low

  * The build problems on sparc are still present due to the old 
    installed new gcc packages. In my opinion the right way to deal with 
    that is to adjust the builddepends to the g++-4.4 (>= 4.4.5-1~) version, 
    that is working on the the porter-boxes. This version is also the current 
    in testing and unstable. The build systems on lebrun should be updated.
  * On ia64 the build fails with an: "internal compiler error" To prevent this 
    I will disable the profiling there. The g++ is now current here. The 
    behavior is different on the porterbox merulo. The plan is to report 
    upstream and test profiling in experimental next release again.

 -- Oliver Korff <ok@xynyx.de>  Sun, 07 Nov 2010 14:14:39 +0100

stockfish (1.9.1-2) experimental; urgency=low

  * The encountered build problems on sparc and ia64 should now be solved 

